package $package;

import javax.jws.WebService;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.ow2.weblab.core.model.Resource;
import org.ow2.weblab.core.services.AccessDeniedException;
import org.ow2.weblab.core.services.ContentNotAvailableException;
import org.ow2.weblab.core.services.InsufficientResourcesException;
import org.ow2.weblab.core.services.InvalidParameterException;
import org.ow2.weblab.core.services.ServiceNotConfiguredException;
import org.ow2.weblab.core.services.Trainable;
import org.ow2.weblab.core.services.UnexpectedException;
import org.ow2.weblab.core.services.UnsupportedRequestException;
import org.ow2.weblab.core.services.trainable.AddTrainResourceArgs;
import org.ow2.weblab.core.services.trainable.AddTrainResourceReturn;
import org.ow2.weblab.core.services.trainable.ResetTrainedModelArgs;
import org.ow2.weblab.core.services.trainable.ResetTrainedModelReturn;
import org.ow2.weblab.core.services.trainable.TrainArgs;
import org.ow2.weblab.core.services.trainable.TrainReturn;

/**
 * Template for WebLab service which uses Trainable interface
 * 
 * @author WebLab Team
 */
@WebService(endpointInterface = "org.ow2.weblab.core.services.Trainable")
public class $className implements Trainable {


	/**
	 * The instance of logger used inside $className
	 */
	private final Log logger;


	/**
	 * Constructor
	 */
	public $className() {
		this.logger = LogFactory.getLog(this.getClass());

		// TODO Initialise other fields if needed

		this.logger.info("Service $className successfully started");
	}


	@Override
	public AddTrainResourceReturn addTrainResource(final AddTrainResourceArgs args) throws AccessDeniedException, ContentNotAvailableException,
			InsufficientResourcesException, InvalidParameterException, ServiceNotConfiguredException, UnexpectedException, UnsupportedRequestException {
		this.logger.debug("Early start of addTrainResource method.");

		final Resource resource = this.checkAddTrainResourceArgs(args);

		this.logger.info("Start processing resource " + resource.getUri() + ".");

		// TODO Implement your method here!

		this.logger.error("Method addTrainResource not yet implemented.");
		throw new UnsupportedRequestException("Method addTrainResource not yet implemented.", "Constructor not yet implemented.");
	}


	protected Resource checkAddTrainResourceArgs(AddTrainResourceArgs args) throws InvalidParameterException {
		if (args == null) {
			throw new InvalidParameterException("AddTrainResourceArgs is null.");
		}
		final Resource resource = args.getResource();
		if (resource == null) {
			throw new InvalidParameterException("Resource in AddTrainResourceArgs is null.");
		}

		// TODO Maybe implement a better test for your resource (for instance, is a Document required?)
		// TODO Test the existence of an usageContext if required

		return resource;
	}


	@Override
	public ResetTrainedModelReturn resetTrainedModel(final ResetTrainedModelArgs args) throws AccessDeniedException, ContentNotAvailableException,
			InsufficientResourcesException, InvalidParameterException, ServiceNotConfiguredException, UnexpectedException, UnsupportedRequestException {
		this.logger.debug("Early start of resetTrainedModel method.");

		final String usageContext = this.checkResetTrainedModelArgs(args);

		this.logger.info("Reset trained model uses usage context " + usageContext + ".");

		// TODO Implement your method here!

		this.logger.error("Method resetTrainedModel not yet implemented.");
		throw new UnsupportedRequestException("Method resetTrainedModel not yet implemented.", "Constructor not yet implemented.");
	}


	private String checkResetTrainedModelArgs(ResetTrainedModelArgs args) throws InvalidParameterException {
		if (args == null) {
			throw new InvalidParameterException("ResetTrainedModelArgs is null.");
		}
		return args.getUsageContext();
	}


	@Override
	public TrainReturn train(final TrainArgs args) throws AccessDeniedException, ContentNotAvailableException, InsufficientResourcesException,
			InvalidParameterException, ServiceNotConfiguredException, UnexpectedException, UnsupportedRequestException {
		this.logger.debug("Early start of train method.");

		final String usageContext = this.checkTrainArgs(args);

		this.logger.info("Train uses usage context " + usageContext + ".");


		// TODO Implement your method here!

		this.logger.error("Method train not yet implemented.");
		throw new UnsupportedRequestException("Method train not yet implemented.", "Constructor not yet implemented.");
	}


	protected String checkTrainArgs(TrainArgs args) throws InvalidParameterException {
		if (args == null) {
			throw new InvalidParameterException("TrainArgs is null.");
		}
		return args.getUsageContext();
	}
}
