package $package;

import org.junit.Before;
import org.junit.Test;
import org.ow2.weblab.core.services.InvalidParameterException;
import org.ow2.weblab.core.services.trainable.AddTrainResourceArgs;

/**
 * Template for WebLab service test which uses Trainable interface
 * 
 * @author WebLab Team
 */
public class $classNameTest {


	/**
	 * Instance of service which implement a Trainable
	 */
	private $className trainable;


	/**
	 * Initialisation before tests
	 */
	@Before
	public void init() {
		this.trainable = new $className();
	}


	/**
	 * Exception tests
	 */
	@Test(expected = InvalidParameterException.class)
	public void testNullAddTrainResourceArgs() throws Exception {
		this.trainable = new $className();
		this.trainable.addTrainResource(null);
	}


	/**
	 * Exception tests
	 */
	@Test(expected = InvalidParameterException.class)
	public void testNullResourceAddTrainResourceArgs() throws Exception {
		this.trainable = new $className();
		this.trainable.addTrainResource(new AddTrainResourceArgs());
	}


	/**
	 * Exception tests
	 */
	@Test(expected = InvalidParameterException.class)
	public void testNullResetTrainedModelArgs() throws Exception {
		this.trainable = new $className();
		this.trainable.resetTrainedModel(null);
	}

	
	/**
	 * Exception tests
	 */
	@Test(expected = InvalidParameterException.class)
	public void testNullTrainArgs() throws Exception {
		this.trainable = new $className();
		this.trainable.train(null);
	}

}